package hopp

import "io"
import "context"

// Conn is a HOPP connection.
type Conn interface {
	io.Closer
	OpenTrans() (Trans, error)
	AcceptTrans(ctx context.Context) (Trans, error)
}

// Trans is a HOPP transaction.
type Trans interface {
	io.Closer
	ID() int64
	// Send sends a message.
	Send(method uint16, data []byte) error
	// Receive receives a message.
	Receive() (method uint16, data []byte, err error)
}
